//+------------------------------------------------------------------+
//|                                           Chande Momentum        |
//+------------------------------------------------------------------+

//---- indicator settings
#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  Orange
#property  indicator_width1  2
#property  indicator_color2  Green
#property  indicator_width2  2
#property  indicator_color3  Red
#property  indicator_width3  2

      
extern int CMO_Period = 15;
extern int Level = 0;

//---- buffers


double cmo1[];
double scmo1[];
double cmo2[];
double scmo2[];
double cmoU[];
double cmoI[];
double cmoD[];
double cmo[];


//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
//---- drawing settings
   
   SetIndexStyle(0,DRAW_LINE);


  // IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+2);



//---- name for DataWindow and indicator subwindow label
   IndicatorShortName("CMO("+CMO_Period+")");
   
   IndicatorBuffers(8);
   SetIndexBuffer(0,cmoI);
   SetIndexBuffer(1,cmoU);
   SetIndexBuffer(2,cmoD);
   SetIndexBuffer(3,cmo);
   SetIndexBuffer(4,cmo1);
   SetIndexBuffer(5,cmo2);
   SetIndexBuffer(6,scmo1);
   SetIndexBuffer(7,scmo2);
   SetIndexDrawBegin(0,CMO_Period);  
   SetIndexDrawBegin(1,CMO_Period);  
   SetIndexDrawBegin(2,CMO_Period);  
   
   //SetIndexStyle(2,DRAW_LINE,STYLE_SOLID,2);
   //SetIndexStyle(1,DRAW_LINE,STYLE_SOLID,2);
   //SetIndexStyle(0,DRAW_LINE,STYLE_SOLID,2);
//---- initialization done
   return(0);
  }

int start()
{
   int i, j, k, limit;
   double dif1, cmo3, cmo4, Tcmo1, Tscmo1, Tcmo2, Tscmo2;
   int    counted_bars=IndicatorCounted();
   if(counted_bars>0) counted_bars--;
   limit=Bars-counted_bars;
  
   for(i = limit+CMO_Period; i >= 0; i--)
     {
       dif1 = Close[i]-Close[i+1];
       if(dif1>=0){ 
         Tcmo1 = dif1;
         Tcmo2 = 0;
       }  
       else {
         Tcmo1 = 0;
         Tcmo2 = -dif1;
       }  
       cmo1[i] = Tcmo1;
       cmo2[i] = Tcmo2;
     }

 
   for(i = limit; i >= 0; i--)
     {
       Tscmo1 = 0;
       for(j = i + CMO_Period-1; j >= i; j--)
         Tscmo1 += cmo1[j];
       scmo1[i] = Tscmo1;
     }

 
   for(i = limit; i >= 0; i--)
     {
       Tscmo2 = 0;
       for(j = i + CMO_Period-1; j >= i; j--)
         Tscmo2 += cmo2[j];
       scmo2[i] = Tscmo2;
     }

//scmo1 - scmo2

//int logCMO=FileOpen(Symbol()+"CMO.csv",FILE_CSV|FILE_WRITE, ';');
//FileWrite(logCMO, "Time[i]", "Close[i]", "Close[i+1]", "Close[i]-Close[i+1]", "cmo1[i]", "scmo1[i]", "cmo2[i]", "scmo2[i]", "cmo3");       
   for(i = limit; i >= 0; i--)
     {
       cmo3 = scmo1[i]-scmo2[i];
       cmo4 = scmo1[i]+scmo2[i];
       if(cmo4!=0)
         cmo[i] = cmo3/cmo4*100; 
       //FileWrite(logCMO, Time[i], Close[i], Close[i+1], Close[i]-Close[i+1], cmo1[i], scmo1[i], cmo2[i], scmo2[i], cmo3, cmo4);       
     }

// FileClose(logCMO);
    //Color Coding
   for(i = limit; i >= 0; i--){
       cmoU[i] = cmo[i];
       cmoI[i] = cmo[i];
       cmoD[i] = cmo[i];

     if(cmo[i]>Level){
       cmoD[i] = EMPTY_VALUE;
     } else
     if(cmo[i]<-Level){
       cmoU[i] = EMPTY_VALUE;
     } else {
       cmoU[i] = EMPTY_VALUE;
       cmoD[i] = EMPTY_VALUE;
     }
   }
   
   
      return(0);
  }
//+------------------------------------------------------------------+



